#include <stdio.h>
#include <string.h>

#define MAX_ENT 256

typedef struct {
	char name[12];
	unsigned short ss;
	unsigned short es;
} FFDIRENT;

static void ffex(char *path)
{
	static FFDIRENT dirent[MAX_ENT];
	int i, j;
	char buf[4096], fname[20], *p;
	unsigned long pos, len;
	FILE *ifp, *ofp;
	ifp = fopen(path, "rb");
	if (ifp == NULL) return;
	fseek(ifp, 0x1400, SEEK_SET);
	fread(dirent, 16, MAX_ENT, ifp);
	for (i = 0; i < MAX_ENT; i++)
	{
		if (dirent[i].name[0] == '\0' || dirent[i].name[7] == '\x40') continue;
		pos = dirent[i].ss * 512;
		len = ((dirent[i].es -  dirent[i].ss) + 1) * 512;
		fseek(ifp, pos, SEEK_SET);
		memcpy(fname, dirent[i].name, 12);
		for (p = fname, j = 0; j < 12; j++)
			if (dirent[i].name[j] != ' ')
				*p++ = dirent[i].name[j];
		*p = '\0';
		ofp = fopen(fname, "wb");
		if (ofp == NULL) break;
		while (len > sizeof(buf))
		{
			fread(buf, 1, sizeof(buf), ifp);
			fwrite(buf, 1, sizeof(buf), ofp);
			len -= sizeof(buf);
		}
		fread(buf, 1, len, ifp);
		fwrite(buf, 1, len, ofp);
		fclose(ofp);
	}
	fclose(ifp);
}

typedef struct {
	char name[12];
	unsigned short size;
	unsigned char str;
	unsigned char sse;
} FHDIRENT;

static void fhex(char *path)
{
	static FHDIRENT dirent[MAX_ENT];
	int i, j;
	char buf[4096], fname[20], *p;
	unsigned long pos, len;
	FILE *ifp, *ofp;
	ifp = fopen(path, "rb");
	if (ifp == NULL) return;
	fseek(ifp, 0x800, SEEK_SET);
	fread(dirent, 16, MAX_ENT, ifp);
	for (i = 0; i < MAX_ENT; i++)
	{
		if (dirent[i].name[0] == '\0') continue;
		if (dirent[i].name[0] == '\x5f') continue;
		if (dirent[i].name[0] == '\xff') break;
		pos = 0;
		pos += ((unsigned)dirent[i].str)        * 18 * 512;
		pos += (((unsigned)dirent[i].sse >> 4))  * 9 * 512;
		pos += (((unsigned)dirent[i].sse & 0xf) - 1) * 512;
		len = dirent[i].size * 512;
		fseek(ifp, pos, SEEK_SET);
		for (p = fname, j = 0; j < 11; j++)
		{
			if (j == 8) *p++ = '.';
			if (dirent[i].name[j] != ' ')
				*p++ = dirent[i].name[j];
		}
		*p = '\0';
		ofp = fopen(fname, "wb");
		printf("%12s o:%08x s:%08x\n", fname, pos, len);
		if (ofp == NULL) break;
		while (len > sizeof(buf))
		{
			fread(buf, 1, sizeof(buf), ifp);
			fwrite(buf, 1, sizeof(buf), ofp);
			len -= sizeof(buf);
		}
		fread(buf, 1, len, ifp);
		fwrite(buf, 1, len, ofp);
		fclose(ofp);
	}
	fclose(ifp);
}


typedef struct {
	char name[12];
	unsigned short ss;
	unsigned short size;
} LENAMDIRENT;

static void lenamex(char *path)
{
	static LENAMDIRENT dirent[MAX_ENT];
	int i, j;
	char buf[4096], fname[20], *p;
	unsigned long pos, len;
	FILE *ifp, *ofp;
	ifp = fopen(path, "rb");
	if (ifp == NULL) return;
	fseek(ifp, 0x800, SEEK_SET);
	fread(dirent, 16, MAX_ENT, ifp);
	for (i = 0; i < MAX_ENT; i++)
	{
		if (dirent[i].name[0] == '\0' || dirent[i].name[7] == '\x40') break;
		pos = dirent[i].ss * 512;
		len = dirent[i].size * 512;
		fseek(ifp, pos, SEEK_SET);
		dirent[i].name[7] = '.';
		for (p = fname, j = 0; j < 12; j++)
			if (dirent[i].name[j] != ' ')
				*p++ = dirent[i].name[j];
		*p = '\0';
		ofp = fopen(fname, "wb");
		if (ofp == NULL) break;
		while (len > sizeof(buf))
		{
			fread(buf, 1, sizeof(buf), ifp);
			fwrite(buf, 1, sizeof(buf), ofp);
			len -= sizeof(buf);
		}
		fread(buf, 1, len, ifp);
		fwrite(buf, 1, len, ofp);
		fclose(ofp);
	}
	fclose(ifp);
}


int main(int argc, char **argv)
{
	int i;
	void (*ex)(char *path) = ffex;
	for (i = 1; i < argc; i++)
	{
		if (stricmp(argv[i], "firehawk") == 0)
			ex = fhex;
		else if (stricmp(argv[i], "ff") == 0)
			ex = ffex;
		else if (stricmp(argv[i], "lenam") == 0)
			ex = lenamex;
		else
			ex(argv[i]);
	}
	return 0;
}